#!/usr/bin/env python

# This application is released under the GNU General Public License 
# v3 (or, at your option, any later version). You can find the full 
# text of the license under http://www.gnu.org/licenses/gpl.txt. 
# By using, editing and/or distributing this software you agree to 
# the terms and conditions of this license. 
# Thank you for using free software!
#
#(c) QB89Dragon 2007/8 <hughescih@hotmail.com>
#(c) Whise 2008,2009 <helderfraga@gmail.com>
#
# Global menu settings
# Part of the GnoMenu


import gtk
import gc
import os
import xml.dom.minidom
import backend
import sys




try:
	INSTALL_PREFIX = open("/etc/gnomenu/prefix").read()[:-1] 
except:
	INSTALL_PREFIX = '/usr'

import gettext

gettext.textdomain('gnomenu')
gettext.install('gnomenu', INSTALL_PREFIX +  '/share/locale')
gettext.bindtextdomain('gnomenu', INSTALL_PREFIX +  '/share/locale')

def _(s):
	return gettext.gettext(s)



global name,version,appdirname 
name = "GnoMenu"
version = "2.0"
appdirname="gnomenu"

############ Set up global directories #########################
################################################################

HomeDirectory = os.path.expanduser("~")
AutoStartDirectory = HomeDirectory + '/.config/autostart/'
ProgramDirectory = INSTALL_PREFIX + "/lib/"+appdirname+"/" 
ThemeDirectory = INSTALL_PREFIX + "/share/"+appdirname+"/Themes/"
GraphicsDirectory = INSTALL_PREFIX + "/lib/"+appdirname+"/graphics/"  
GladeSettingsFile = INSTALL_PREFIX + "/lib/"+appdirname+"/settings-window.glade"  

########### Definitions ########################################
################################################################

ThemeCategories = ["Menu","Icon","Button"]
gconf_app_key = '/apps/gnomenu'



########## Load default settings  ##############################
################################################################

def SetDefaultSettings():
	global Bind_Key, Show_Tips, Show_Thumb, System_Icons, Sound_Theme,Menu_Name,MenuActions,Theme, MenuCommands, Language, Isize,IconSize,ListSize,ImageDirectory,Actions, IconTheme, IconDirectory, GladeFile,MenuButtonTheme,MenuButtonDirectory,ThemeColor,ShowTop,TransitionQ,TransitionS,PGTheme,GtkColors,TabHover, Shownetandemail,FirstUse,SuperL,Search,Network_Config,Control_Panel,Package_Manager,Help,Power,Shutdown, Suspend, Hibernate, Lock,Run, Logout,LogoutNow, Restart, ClearRecent,Prog_List,User,Tab_Efect

	backend.save_setting("Tab_Efect",1)
	backend.save_setting("Bind_Key","Super_L")
	backend.save_setting("Sound_Theme","None")
	backend.save_setting("Show_Thumb",0)
	backend.save_setting("Show_Tips",0)
	backend.save_setting("Prog_List",0)
	backend.save_setting("System_Icons",0)
	backend.save_setting("Menu_Name","Menu")
	backend.save_setting("IconSize",32)
	backend.save_setting("ListSize",10)
	backend.save_setting("SuperL",1)
	backend.save_setting("Icon_Name","Newstyles")
	backend.save_setting("Button_Name","GnoBlue")
	backend.save_setting("Shownetandemail",1)
	backend.save_setting("GtkColors",0)
	backend.save_setting("TabHover",0)
	backend.save_setting("Search","gnome-search-tool")
	backend.save_setting("Network_Config","nm-connection-editor")
	backend.save_setting("Control_Panel","gnome-control-center")
	backend.save_setting("Package_Manager","gksu synaptic")
	backend.save_setting("Help", "yelp")
	backend.save_setting("Power","gnome-session-save --shutdown-dialog")
	backend.save_setting("Lock","gnome-screensaver-command --lock")
	backend.save_setting("Suspend",'python -u ' + ProgramDirectory + "session-manager.py suspend")
	backend.save_setting("Shutdown",'python -u ' + ProgramDirectory + "session-manager.py shutdown")
	backend.save_setting("Hibernate",'python -u ' + ProgramDirectory + "session-manager.py hibernate")
	backend.save_setting("Run",ProgramDirectory + "Gnome_run_dialog.py")
	backend.save_setting("Logout","gnome-session-save --logout-dialog")
	backend.save_setting("LogoutNow","gnome-session-save --logout")
	backend.save_setting("Restart",'python -u ' + ProgramDirectory + "session-manager.py reboot")
	backend.save_setting("User","gnome-about-me")
	backend.save_setting("AdminRun","gksu")


# Load settings stored in XML
def ReloadSettings():

	def SetDefaultSettings():
		global Bind_Key, Show_Tips, Show_Thumb, System_Icons, Sound_Theme,Menu_Name,MenuActions,Theme, MenuCommands, Language, Isize,IconSize,ListSize,ImageDirectory,Actions, IconTheme, IconDirectory, GladeFile,MenuButtonTheme,MenuButtonDirectory,ThemeColor,ShowTop,TransitionQ,TransitionS,PGTheme,GtkColors,TabHover, Shownetandemail,FirstUse,SuperL,Search,Network_Config,Control_Panel,Package_Manager,Help,Power,Shutdown,Suspend, Hibernate, Lock,Run, Logout, LogoutNow, Restart, ClearRecent,Prog_List,User, AdminRun,Tab_Efect

		backend.save_setting("Tab_Efect",1)
		backend.save_setting("Bind_Key","Super_L")
		backend.save_setting("Sound_Theme","None")
		backend.save_setting("Show_Thumb",0)
		backend.save_setting("Show_Tips",0)
		backend.save_setting("Prog_List",0)
		backend.save_setting("System_Icons",0)
		backend.save_setting("Menu_Name","Menu")
		backend.save_setting("IconSize",32)
		backend.save_setting("ListSize",10)
		backend.save_setting("SuperL",1)
		backend.save_setting("Icon_Name","Newstyles")
		backend.save_setting("Button_Name","GnoBlue")
		backend.save_setting("Shownetandemail",1)
		backend.save_setting("GtkColors",0)
		backend.save_setting("TabHover",0)
		backend.save_setting("Search","gnome-search-tool")
		backend.save_setting("Network_Config","nm-connection-editor")
		backend.save_setting("Control_Panel","gnome-control-center")
		backend.save_setting("Package_Manager","gksu synaptic")
		backend.save_setting("Help", "yelp")
		backend.save_setting("Power","gnome-session-save --shutdown-dialog")
		backend.save_setting("Lock","gnome-screensaver-command --lock")
		backend.save_setting("Shutdown",'python -u ' + ProgramDirectory + "session-manager.py shutdown")
		backend.save_setting("Suspend",'python -u ' + ProgramDirectory + "session-manager.py suspend")
		backend.save_setting("Hibernate",'python -u ' + ProgramDirectory + "session-manager.py hibernate")
		backend.save_setting("Run",ProgramDirectory + "Gnome_run_dialog.py")
		backend.save_setting("Logout","gnome-session-save --logout-dialog")
		backend.save_setting("LogoutNow","gnome-session-save --logout")
		backend.save_setting("Restart",'python -u ' + ProgramDirectory + "session-manager.py reboot")
		backend.save_setting("User","gnome-about-me")
		backend.save_setting("AdminRun","gksu")

		Show_Tips = 0
		Show_Thumb = 0
		Prog_List = 0
		System_Icons = 0

		Tab_Efect = backend.load_setting("Tab_Efect")
		Bind_Key = backend.load_setting("Bind_Key")
		Sound_Theme = backend.load_setting("Sound_Theme")
		Menu_Name = Theme = backend.load_setting("Menu_Name")
		IconSize = Isize = backend.load_setting("IconSize")
		ListSize = backend.load_setting("ListSize")
		SuperL = backend.load_setting("SuperL")
		ThemeColor = 'white'
		IconTheme = backend.load_setting("Icon_Name")
		MenuButtonTheme = backend.load_setting("Button_Name")
		ShowTop = 1
		PGTheme = "Classic"
		TransitionS = 25
		TransitionQ = 0.05
		Shownetandemail = backend.load_setting("Shownetandemail")
		GtkColors = backend.load_setting("GtkColors")
		TabHover = backend.load_setting("TabHover")
		Search = backend.load_setting("Search")
		Network_Config = backend.load_setting("Network_Config")
		Control_Panel = backend.load_setting("Control_Panel")
		Package_Manager = backend.load_setting("Package_Manager")
		Help = backend.load_setting("Help")
		Power = backend.load_setting("Power")
		Shutdown = backend.load_setting("Shutdown")
		Lock = backend.load_setting("Lock")
		Suspend = backend.load_setting("Suspend")
		Hibernate = backend.load_setting("Hibernate")
		Run = ProgramDirectory + "Gnome_run_dialog.py"
		ClearRecent = 'python -u ' +ProgramDirectory + "clean-recently-used.py -R"
		Logout = backend.load_setting("Logout")
		LogoutNow = backend.load_setting("LogoutNow")
		Restart = backend.load_setting("Restart")
		User = backend.load_setting("User")
		AdminRun = backend.load_setting("AdminRun")



	def GetSettings():
		global Bind_Key, Show_Tips, Show_Thumb, System_Icons, Sound_Theme, Menu_Name, MenuActions,Theme, MenuCommands, Language, Isize,IconSize,ListSize,ImageDirectory,Actions, IconTheme, IconDirectory, GladeFile,MenuButtonTheme,MenuButtonDirectory,ThemeColor,ShowTop,TransitionQ,TransitionS,PGTheme,GtkColors,TabHover, Shownetandemail,FirstUse,SuperL,Search,Network_Config,Control_Panel,Package_Manager,Help,Power,Shutdown, Suspend, Hibernate, Lock,Run, Logout, LogoutNow, Restart, ClearRecent,Prog_List,User, AdminRun,Tab_Efect

		Tab_Efect = backend.load_setting("Tab_Efect")
		Bind_Key = backend.load_setting("Bind_Key")
		System_Icons = backend.load_setting("System_Icons")
		Sound_Theme = backend.load_setting("Sound_Theme")
		Show_Thumb = backend.load_setting("Show_Thumb")
		Show_Tips = backend.load_setting("Show_Tips")
		Prog_List = backend.load_setting("Prog_List")
		Menu_Name = Theme = backend.load_setting("Menu_Name")
		IconSize = Isize = backend.load_setting("IconSize")
		ListSize = backend.load_setting("ListSize")
		SuperL = backend.load_setting("SuperL")
		ThemeColor = 'white'
		IconTheme = backend.load_setting("Icon_Name")
		MenuButtonTheme = backend.load_setting("Button_Name")
		ShowTop = 1
		PGTheme = "Classic"
		TransitionS = 25
		TransitionQ = 0.05
		Shownetandemail = backend.load_setting("Shownetandemail")
		GtkColors = backend.load_setting("GtkColors")
		TabHover = backend.load_setting("TabHover")
		Search = backend.load_setting("Search")
		Network_Config = backend.load_setting("Network_Config")
		Control_Panel = backend.load_setting("Control_Panel")
		Package_Manager = backend.load_setting("Package_Manager")
		Help = backend.load_setting("Help")
		Power = backend.load_setting("Power")
		Shutdown = backend.load_setting("Shutdown")
		Lock = backend.load_setting("Lock")
		Suspend = backend.load_setting("Suspend")
		Hibernate = backend.load_setting("Hibernate")
		Run = ProgramDirectory + "Gnome_run_dialog.py"
		ClearRecent = 'python -u ' +ProgramDirectory + "clean-recently-used.py -R"
		Logout = backend.load_setting("Logout")
		LogoutNow = backend.load_setting("LogoutNow")
		Restart = backend.load_setting("Restart")
		User = backend.load_setting("User")
		AdminRun = backend.load_setting("AdminRun")




# Loads the main configuration and settings file to their respective values


	global Bind_Key, Show_Thumb, Show_Tips, System_Icons, Sound_Theme, orientation,panel_size,flip, MenuActions,Menu_Name, Theme, MenuCommands, Language, Isize,IconSize,ListSize,ImageDirectory,Actions, IconTheme, IconDirectory, GladeFile,MenuButtonTheme,MenuButtonDirectory,ThemeColor,ShowTop,TransitionQ,TransitionS,PGTheme,GtkColors,TabHover, Shownetandemail,FirstUse,SuperL,Search,Network_Config,Control_Panel,Package_Manager,Help,Power,Shutdown,Suspend, Hibernate, Lock,Run, Logout, LogoutNow,Restart, ClearRecent, StartMenuTemplate,ThemeColorCode,MenuWidth, MenuHeight, IconW, IconH, IconInX, IconInY, IconInW, IconInH, SearchX, SearchY, SearchW, SearchH, SearchIX, SearchIY, SearchInitialText,SearchTextColor, SearchBackground, SearchWidget, SearchWidgetPath, UserIconFrameOffsetX, UserIconFrameOffsetY,UserIconFrameOffsetH, UserIconFrameOffsetW,PG_buttonframe,PG_buttonframedimensions,MenuHasSearch, MenuHasIcon, MenuHasFade , OnlyShowFavs, OnlyShowRecentApps, CairoSearchTextColor, CairoSearchBackColor, CairoSearchBorderColor,CairoSearchRoundAngle, PG_iconsize,RI_numberofitems, MenuButtonCount, MenuButtonNames, MenuButtonMarkup, MenuButtonNameOffsetX, MenuButtonNameOffsetY, MenuButtonCommands,MenuButtonX,MenuButtonY,MenuButtonImage, MenuButtonIcon, MenuButtonIconSel, MenuButtonExecOnHover, MenuButtonSub,MenuButtonClose, MenuCairoIcon, MenuLabelCount, MenuLabelNames, MenuLabelMarkup,MenuLabelX,MenuLabelY,MenuLabelCommands, MenuTabCount, MenuTabNames, MenuTabMarkup, MenuTabNameOffsetX, MenuTabNameOffsetY, MenuTabCommands,MenuTabX,MenuTabY,MenuTabImage, MenuTabIcon, MenuTabImageSel, MenuTabSub,MenuTabClose, MenuCairoIcontab, MenuImageCount, MenuImageNames,MenuImageX,MenuImageY,MenuImage, ButtonHasTop, ButtonLabelCount, ButtonHasBottom,ButtonLabelName,ButtonLabelMarkup,ButtonLabelX,ButtonLabelY, Prog_List,User,AdminRun,Tab_Efect,Has_Numpy


	try:
		import numpy
		Has_Numpy = True
	except:
		Has_Numpy = False
		print 'python numpy not installed , some effects and gtk native colors wont be available'

	orientation = None
	panel_size = 30
	flip = None
	orientation = backend.load_setting("orientation")
	panel_size = backend.load_setting("size")
	if orientation == 'top':
		flip = False
	elif orientation == 'bottom':
		flip = None
	while gtk.events_pending():
		gtk.main_iteration()
	
	FirstUse = False
	GetSettings()
	if Menu_Name == None or Restart == None or Logout == None or LogoutNow == None or Run == None or Lock == None or Power == None or Help == None or Package_Manager == None or Control_Panel == None or Network_Config == None or Search == None or GtkColors == None or TabHover == None or Shownetandemail == None or TransitionQ == None or TransitionS == None or PGTheme == None or MenuButtonTheme == None or IconTheme == None or ThemeColor == None or SuperL == None or ListSize == None or IconSize == None or Theme == None or Prog_List == None or Sound_Theme == None or System_Icons == None or Show_Thumb == None or Show_Tips == None or Bind_Key == None or Suspend == None or Hibernate == None or Shutdown == None or User == None or AdminRun == None or Tab_Efect == None:
		SetDefaultSettings()
		FirstUse = True
		GetSettings()

	MenuActions = []
	MenuCommands = []
	MenuActions.append('Search')
	MenuCommands.append(Search)
	MenuActions.append('Network Config')
	MenuCommands.append(Network_Config)
	MenuActions.append('Control Panel')
	MenuCommands.append(Control_Panel)
	MenuActions.append('Package Manager')
	MenuCommands.append(Package_Manager)
	MenuActions.append('Help')
	MenuCommands.append(Help)
	MenuActions.append('Power')
	MenuCommands.append(Power)
	MenuActions.append('Shutdown')
	MenuCommands.append(Shutdown)
	MenuActions.append('Lock')
	MenuCommands.append(Lock)
	MenuActions.append('Suspend')
	MenuCommands.append(Suspend)
	MenuActions.append('Hibernate')
	MenuCommands.append(Hibernate)
	MenuActions.append('Run')
	MenuCommands.append(Run)
	MenuActions.append('Logout')
	MenuCommands.append(Logout)
	MenuActions.append('LogoutNow')
	MenuCommands.append(LogoutNow)
	MenuActions.append('Restart')
	MenuCommands.append(Restart)




	ImageDirectory = INSTALL_PREFIX + "/share/"+appdirname+"/Themes/Menu/"+Theme+"/"
	IconDirectory = INSTALL_PREFIX + "/share/"+appdirname+"/Themes/Icon/"+IconTheme+"/"
	MenuButtonDirectory = INSTALL_PREFIX + "/share/"+appdirname+"/Themes/Button/"+MenuButtonTheme+"/"


	#Size of icons in the program list (default is 24)
	PG_iconsize = int(float(Isize))
	#Recent Items Menu
	RI_numberofitems = int(float(ListSize))

	try:
		XMLSettings = xml.dom.minidom.parse(ImageDirectory+"themedata.xml")
	except:
		SetDefaultSettings()
		XMLSettings = xml.dom.minidom.parse(ImageDirectory+"themedata.xml")
	XContent = XMLSettings.childNodes[0].getElementsByTagName("theme")
	# Identify correct theme style element
	Found = 0
	for node in XContent:
		if node.attributes["color"].value == ThemeColor or node.attributes["color"].value == "All":
			XBase = node
			ThemeColorCode = node.attributes["colorvalue"].value
			Found = 1
	if Found==0:
		print "Error: Failed to find theme color:" + ThemeColor
		print "The available values are:"
		for node in XContent:
			print node.attributes["color"].value
		sys.exit()
		
	# Load Background Image
	SBase = XBase.getElementsByTagName("Background")
	StartMenuTemplate = SBase[0].attributes["Image"].value
	

	# Load WindowDimensions
	SBase = XBase.getElementsByTagName("WindowDimensions")
	MenuWidth = int(SBase[0].attributes["Width"].value)
	MenuHeight = int(SBase[0].attributes["Height"].value)

	# Load WindowDimensions
	SBase = XBase.getElementsByTagName("IconSettings")
	UserIconFrameOffsetX = int(SBase[0].attributes["X"].value)
	UserIconFrameOffsetW = int(SBase[0].attributes["Width"].value)
	UserIconFrameOffsetH = int(SBase[0].attributes["Height"].value)
	if orientation == 'botton':
		UserIconFrameOffsetY = int(SBase[0].attributes["Y"].value)

	elif orientation == 'top':

		UserIconFrameOffsetY =  MenuHeight - int(SBase[0].attributes["Y"].value) - UserIconFrameOffsetH
	else:
		UserIconFrameOffsetY = int(SBase[0].attributes["Y"].value)

	IconW = int(SBase[0].attributes["Width"].value)
	IconH = int(SBase[0].attributes["Height"].value)
	IconInX = int(SBase[0].attributes["InsetX"].value)
	IconInY = int(SBase[0].attributes["InsetY"].value)
	IconInW = int(SBase[0].attributes["InsetWidth"].value)
	IconInH = int(SBase[0].attributes["InsetHeight"].value)

	# Load SearchBarSettings
	SBase = XBase.getElementsByTagName("SearchBarSettings")
	SearchWidget = SBase[0].attributes["Widget"].value
	if SearchWidget != "None":
		# Load universal values
		SearchX = int(SBase[0].attributes["X"].value)
		SearchW = int(SBase[0].attributes["Width"].value)
		SearchH = int(SBase[0].attributes["Height"].value)
		if orientation == 'bottom':
			SearchY = int(SBase[0].attributes["Y"].value)
		elif orientation == 'top':

			SearchY = MenuHeight -  int(SBase[0].attributes["Y"].value) - SearchH
		else:
			SearchY = int(SBase[0].attributes["Y"].value)
		# Load theme-only values
		if SearchWidget == "Custom":
			SearchIX = int(SBase[0].attributes["InsetX"].value) 
			SearchIY = int(SBase[0].attributes["InsetY"].value)
			SearchInitialText = SBase[0].attributes["InitialText"].value
			try:SearchTextColor = SBase[0].attributes["TextColor"].value
			except:SearchTextColor = "#000000"
				
			SearchBackground = SBase[0].attributes["Background"].value
			SearchWidgetPath = SBase[0].attributes["WidgetName"].value
		if SearchWidget == "Cairo":
			try:CairoSearchTextColor = SBase[0].attributes["TextColor"].value
			except:CairoSearchTextColor = "#000000"
			try:CairoSearchBackColor = SBase[0].attributes["BackColor"].value
			except:CairoSearchBackColor = "#FFFFFF"
			try:CairoSearchBorderColor = SBase[0].attributes["BorderColor"].value
			except:CairoSearchBorderColor = "#000000"				
			try:CairoSearchRoundAngle = int(SBase[0].attributes["RoundAngle"].value)
			except:CairoSearchRoundAngle = 0	

	# Load ProgramListSettings
	SBase = XBase.getElementsByTagName("ProgramListSettings")
	PG_buttonframedimensions = int(SBase[0].attributes["Width"].value),int(SBase[0].attributes["Height"].value)
	if orientation == 'botton':
		PG_buttonframe = int(SBase[0].attributes["X"].value),int(SBase[0].attributes["Y"].value)
	elif orientation == 'top':
		PG_buttonframe = int(SBase[0].attributes["X"].value),MenuHeight - int(SBase[0].attributes["Y"].value) - int(PG_buttonframedimensions[1])
	else:
		PG_buttonframe = int(SBase[0].attributes["X"].value),int(SBase[0].attributes["Y"].value)
	try:
		OnlyShowFavs = int(SBase[0].attributes["OnlyShowFavs"].value)
	except:
		OnlyShowFavs = 0

	try:
		OnlyShowRecentApps = int(SBase[0].attributes["OnlyShowRecentApps"].value)
	except:
		OnlyShowRecentApps = 0

	# Load Capabilities
	SBase = XBase.getElementsByTagName("Capabilities")
	MenuHasSearch = int(SBase[0].attributes["HasSearch"].value)
	MenuHasIcon = int(SBase[0].attributes["HasIcon"].value)
	MenuHasFade = int(SBase[0].attributes["HasFadeTransition"].value)

	#Load Menu Button List
	MenuButtons = XBase.getElementsByTagName("Button")
	MenuButtonCount = len(MenuButtons)	
	MenuButtonNames = []
	MenuButtonMarkup = []
	MenuButtonNameOffsetX = []
	MenuButtonNameOffsetY = []
	MenuButtonX = []
	MenuButtonY = []
	MenuButtonImage = []
	MenuButtonIcon = []
	MenuButtonIconSel = []
	MenuButtonExecOnHover = []
	MenuCairoIcon = []
	MenuButtonSub = []
	MenuButtonCommands = []
	MenuButtonClose = []

	for node in MenuButtons:
		try:
			im = gtk.gdk.pixbuf_new_from_file(ImageDirectory + node.attributes["Image"].value)
		except:SetDefaultSettings()
		h = im.get_height()
		
		MenuButtonNames.append(node.attributes["Name"].value)
		MenuButtonMarkup.append(node.attributes["Markup"].value)
		MenuButtonNameOffsetX.append(int(node.attributes["TextX"].value))
		MenuButtonImage.append(node.attributes["Image"].value)    	    	
		MenuButtonIcon.append(node.attributes["ButtonIcon"].value)    	    	
		try:
			MenuButtonExecOnHover.append(int(node.attributes["ExecuteOnHover"].value))
		except: MenuButtonExecOnHover.append(0)
		MenuButtonIconSel.append(node.attributes["ButtonIconSel"].value)    	    	
		MenuCairoIcon.append(node.attributes["Icon"].value)    	    	
		MenuButtonX.append(int(node.attributes["ButtonX"].value))
		if orientation == 'botton':
			MenuButtonNameOffsetY.append(int(node.attributes["TextY"].value))
			MenuButtonY.append(int(node.attributes["ButtonY"].value))
		elif orientation == 'top':

			MenuButtonNameOffsetY.append(int(node.attributes["TextY"].value) )
			MenuButtonY.append(MenuHeight - int(node.attributes["ButtonY"].value) -h )
		else:
			MenuButtonNameOffsetY.append(int(node.attributes["TextY"].value))
			MenuButtonY.append(int(node.attributes["ButtonY"].value))

		MenuButtonCommands.append(node.attributes["Command"].value)
		MenuButtonSub.append(int(node.attributes["SubMenu"].value))
		MenuButtonClose.append(int(node.attributes["CloseMenu"].value))

	#Load Menu Label List

	MenuLabels = XBase.getElementsByTagName("Label")
	MenuLabelCount = len(MenuLabels)
	MenuLabelNames = []
	MenuLabelMarkup = []
	MenuLabelCommands = []
	MenuLabelX = []
	MenuLabelY = []
	for node in MenuLabels:
		MenuLabelNames.append(node.attributes["Name"].value)
		MenuLabelMarkup.append(node.attributes["Markup"].value)	
		MenuLabelX.append(int(node.attributes["LabelX"].value))
		if orientation == 'botton':
			MenuLabelY.append(int(node.attributes["LabelY"].value))
		elif orientation == 'top':
			MenuLabelY.append(MenuHeight - int(node.attributes["LabelY"].value))
		else:
			MenuLabelY.append(int(node.attributes["LabelY"].value))
		MenuLabelCommands.append(node.attributes["Command"].value)

	#Load Menu Tab List
	MenuTabs = XBase.getElementsByTagName("Tab")
	MenuTabCount = len(MenuTabs)
	MenuTabNames = []
	MenuTabMarkup = []
	MenuTabNameOffsetX = []
	MenuTabNameOffsetY = []
	MenuTabX = []
	MenuTabY = []
	MenuTabImage = []
	MenuTabIcon = []
	MenuTabImageSel = []
	MenuCairoIcontab = []
	MenuTabSub = []
	MenuTabCommands = []
	MenuTabClose = []
	for node in MenuTabs:

		try:
			im = gtk.gdk.pixbuf_new_from_file(ImageDirectory + node.attributes["Image"].value)
			h = im.get_height()
		except:
			im = gtk.gdk.pixbuf_new_from_file(ImageDirectory + node.attributes["ImageSel"].value)
			h = im.get_height()		
		MenuTabNames.append(node.attributes["Name"].value)
		MenuTabMarkup.append(node.attributes["Markup"].value)
		MenuTabNameOffsetX.append(int(node.attributes["TextX"].value))
		MenuTabImage.append(node.attributes["Image"].value)    	    	
		MenuTabImageSel.append(node.attributes["ImageSel"].value)    	    	
		MenuTabIcon.append(node.attributes["TabIcon"].value)    	    	
		MenuCairoIcontab.append(node.attributes["Icon"].value)    	    	
		MenuTabX.append(int(node.attributes["TabX"].value))
		if orientation == 'botton':
			MenuTabNameOffsetY.append(int(node.attributes["TextY"].value))
			MenuTabY.append(int(node.attributes["TabY"].value))
		elif orientation == 'top':

			MenuTabNameOffsetY.append(int(node.attributes["TextY"].value) )
			MenuTabY.append(MenuHeight - int(node.attributes["TabY"].value) -h )
		else:
			MenuTabNameOffsetY.append(int(node.attributes["TextY"].value))
			MenuTabY.append(int(node.attributes["TabY"].value))

		MenuTabCommands.append(node.attributes["Command"].value)
		MenuTabSub.append(int(node.attributes["SubMenu"].value))
		MenuTabClose.append(int(node.attributes["CloseMenu"].value))

	#Load menu images

	MenuImages = XBase.getElementsByTagName("Image")
	MenuImageCount = len(MenuImages)
	MenuImageNames = []
	MenuImageX = []
	MenuImageY = []
	MenuImage = []
	for node in MenuImages:

		im = gtk.gdk.pixbuf_new_from_file(ImageDirectory + node.attributes["Image"].value)
		h = im.get_height()
		
		MenuImageNames.append(node.attributes["Name"].value)
		MenuImage.append(node.attributes["Image"].value)    	    	
		MenuImageX.append(int(node.attributes["ImageX"].value))
		if orientation == 'botton':
			MenuImageY.append(int(node.attributes["ImageY"].value))
		elif orientation == 'top':
			MenuImageY.append(MenuHeight - int(node.attributes["ImageY"].value) -h )
		else:
			MenuImageY.append(int(node.attributes["ImageY"].value))

	# Menu button

	try:
		XMLSettings = xml.dom.minidom.parse(MenuButtonDirectory+"themedata.xml")
	except:
		SetDefaultSettings()
		XMLSettings = xml.dom.minidom.parse(MenuButtonDirectory+"themedata.xml")
	XBase = XMLSettings.getElementsByTagName("theme")

	ButtonHasTop = int(XBase[0].attributes["Top"].value)

	if ButtonHasTop==0:
		ShowTop=0
	try:
		XMLSettings = xml.dom.minidom.parse(MenuButtonDirectory+"themedata.xml")
	except:
		SetDefaultSettings()
		XMLSettings = xml.dom.minidom.parse(MenuButtonDirectory+"themedata.xml")
	XBase = XMLSettings.childNodes[0].childNodes[1]
	ButtonLabels = XMLSettings.getElementsByTagName("Label")
	ButtonLabelCount = len(ButtonLabels)
	ButtonLabelName = ""
	ButtonLabelMarkup = ""
	ButtonLabelX = 0
	ButtonLabelY = 0
	if ButtonLabelCount != []:
		for node in ButtonLabels:
		
			ButtonLabelName= (node.attributes["Name"].value)
			ButtonLabelMarkup = (node.attributes["MarkupNormal"].value)	
			ButtonLabelX = (int(node.attributes["LabelX"].value))
			ButtonLabelY = (int(node.attributes["LabelY"].value))



String_list = ['Start','Menu','Control Panel','Favorites','Applications','Computer','Recently Used','Recent', 'Recent Documents', 'Recent Items', 'Recent Applications','Web Bookmarks','Show History','History','Leave','Shutdown','Lock Screen','Lock','Lock Computer','Home Folder', 'Personal Folder' , 'Home','Network','Connect','Connect To','Connect To Server','Connect to Server','Package Manager','Help','Power','Search','About Me','Log Out','Shutdown Computer','Shut Down...','Shut Down','Run','Run Application', 'Execute Application','All Applications', 'All Programs','Help And Support','Logout','System','Control Center','Install Software','Status','Programs','User','Distro','Hdd','Used','Music','Videos', 'Pictures','Documents','Games','Suspend','Hibernate']

String_list_translated = [_('Start'),_('Menu'),_('Control Panel'),_('Favorites'),_('Applications'),_('Computer'),_('Recently Used'),_('Recent'),_('Recent Documents'),_('Recent Items'),_('Recent Applications'),_('Web Bookmarks'),_('Show History'),_('History'),_('Leave'),_('Shutdown'),_('Lock Screen'),_('Lock'),_('Lock Computer'),_('Home Folder'),_('Personal Folder') ,_('Home'),_('Network'),_('Connect'),_('Connect To'),_('Connect To Server'),_('Connect to Server'),_('Package Manager'),_('Help'),_('Power'),_('Search'),_('About Me'),_('Log Out'),_('Shutdown Computer'),_('Shut Down...'),_('Shut Down'),_('Run'),_('Run Application'),_('Execute Application'),_('All Applications'),_('All Programs'),_('Help And Support'),_('Logout'),_('System'),_('Control Center'),_('Install Software'),_('Status'),_('Programs'),_('User'),_('Distro'),_('Hdd'),_('Used'),_('Music'),_('Videos') ,_('Pictures'),_('Documents'),_('Games'),_('Suspend'),_('Hibernate')]

try:
	ReloadSettings()
except:
	SetDefaultSettings()
	ReloadSettings()
#Screen width/height
__screen = gtk.gdk.screen_get_default()
geom = gtk.gdk.Screen.get_monitor_geometry(__screen, 0)
screenwidth = geom.width
screenheight = geom.height

#Basemenu parse (saves the delay everytime the menu is opened)
BaseMenu=""
# Obtain OS default icon theme
DefaultIconTheme = gtk.settings_get_default().get_property("gtk-icon-theme-name")

#Main Start Button
#States:
# 0 = Normal
# 1 = Glowing (mouse-over)
# 2 = Depressed
              
# Blue glowy orb main
StartButton = (MenuButtonDirectory+"start-here.png",
               MenuButtonDirectory+"start-here-glow.png",
               MenuButtonDirectory+"start-here-depressed.png")
               
# Blue glowy orb top part
StartButtonTop = (MenuButtonDirectory+"start-here-top.png",
                     MenuButtonDirectory+"start-here-top-glow.png",
                     MenuButtonDirectory+"start-here-top-depressed.png",
                     MenuButtonDirectory+"start-here-bottom.png",
                     MenuButtonDirectory+"start-here-bottom-glow.png",
                     MenuButtonDirectory+"start-here-bottom-depressed.png")

StartMenuXOffset = -2
StartMenuYOffset = 0

StartMenuTextX = -2
StartMenuTextY = 0

MenuCairoSystemIcon = {'m_webbookmarks':'user-bookmarks','m_recentapps':'applications-other','m_shutdown':'system-shutdown','m_applications':'applications-accessories','m_favorites':'emblem-favorite','firefox_icon':'web-browser','m_computer':'computer','m_connect':'gnome-network-properties','m_controlpanel':'gnome-control-center','m_documents':'folder-documents','m_games':'applications-games','m_help':'gnome-help','m_home':'folder-home', 'm_music':'folder-music' ,'m_network':'gtk-network','m_pictures':'folder-images','m_recentitems':'document-open-recent' ,'m_search':'search' ,'m_synaptic':'emblem-package' ,'m_videos':'folder-videos' ,'no-user-image':'gtk-missing-image' ,'thunderbird_icon':'evolution','m_trash':'trash','m_trash':'user-trash','m_terminal':'terminal','m_run':'gtk-execute','m_lockscreen':'lock','m_logoutuser':'system-switch-user','m_software':'system-software-install'}

#User Image
UserImageFrame = ImageDirectory+"user-image-frame.png"
DefaultUserImage = IconDirectory+"no-user-image.png"
UserImage = os.getenv('HOME') + "/.face"
if os.path.isfile(UserImage) == 0:
    UserImage=DefaultUserImage

#Application logo
Applogo = GraphicsDirectory +"logo.png"
BrokenImage = GraphicsDirectory + "/brokenlink.png"

#Web and Email  FIXME This is not customisable
#Browser = IconDirectory+"firefox_icon.png"
#Email = IconDirectory+"thunderbird_icon.png"

M_CurrentIconSet = ""
elist = []
ebuttonnamelist = []
ebuttoniconlist = []
etypelist = []
gc.collect()
        
