#!/usr/bin/env python

# This application is released under the GNU General Public License 
# v3 (or, at your option, any later version). You can find the full 
# text of the license under http://www.gnu.org/licenses/gpl.txt. 
# By using, editing and/or distributing this software you agree to 
# the terms and conditions of this license. 
# Thank you for using free software!
#
#(c) QB89Dragon 2007/8 <hughescih@hotmail.com>
#(c) Whise 2008,2009 <helderfraga@gmail.com>
#
# Menu window
# Part of the GnoMenu

import sys
import pygtk
pygtk.require("2.0")
import gtk
#import gtk.glade
import gobject
import cairo
#import pango
import os
import string
import urllib
import pango
from Menu_Widgets import MenuButton , Separator, ImageFrame, ProgramList, MenuTab, MenuLabel, MenuImage,TreeProgramList, CairoProgramList
import Globals
try:
	import xdg.BaseDirectory as bd
except:pass
try:
	has_gst = True
	import gst
except:
	has_gst = False

try:
	INSTALL_PREFIX = open("/etc/gnomenu/prefix").read()[:-1] 
except:
	INSTALL_PREFIX = '/usr'

import gettext

gettext.textdomain('gnomenu')
gettext.install('gnomenu', INSTALL_PREFIX +  '/share/locale')
gettext.bindtextdomain('gnomenu', INSTALL_PREFIX +  '/share/locale')

def _(s):
	return gettext.gettext(s)





# Class for a button object from menu


class Main_Menu:
	
	first_time = True
	def __init__(self, hide_method):
		print 'start'
		self.hide_method = hide_method
		#Set the main working directory to home
		os.chdir(Globals.HomeDirectory)
		self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
		self.window.set_focus_on_map(1)
		self.window.set_app_paintable(1)
		self.window.set_skip_taskbar_hint(1)
		self.window.set_skip_pager_hint(1)
		self.window.set_decorated(0)
		self.window.set_keep_above(0)	   #Make this always above other windows
		self.window.stick()			#Make this appear on all desktops
		self.window.set_default_size(Globals.MenuWidth,Globals.MenuHeight)
		self.window.set_events(gtk.gdk.ALL_EVENTS_MASK)
		self.setup()
		self.window.connect("composited-changed", self.composite_changed)
		self.window.connect("expose_event", self.expose)
		self.window.connect("destroy", gtk.main_quit)	#Fixme?
		self.window.connect("focus-out-event", self.lose_focus)
		self.window.connect("key-press-event", self.key_down)
		self.gtk_screen = self.window.get_screen()
		colormap = self.gtk_screen.get_rgba_colormap()
		if colormap == None:
			colormap = self.gtk_screen.get_rgb_colormap()
		gtk.widget_set_default_colormap(colormap)  
		if not self.window.is_composited():

			self.supports_alpha = False
		else:
			self.supports_alpha = True
		#print self.sys_get_window_manager()
		#try:
		#	if self.sys_get_window_manager() == 'compiz':
		#		pass#self.window.set_type_hint(gtk.gdk.WINDOW_TYPE_HINT_MENU)
		#except:pass
		self.w,self.h = self.window.get_size()
		self.leave_focus = True
		self.callback_search = None

	def sys_get_window_manager(self):
		"""Returns window manager name"""
		root = gtk.gdk.get_default_root_window()
		try:
			ident = root.property_get("_NET_SUPPORTING_WM_CHECK", "WINDOW")[2]
			_WM_NAME_WIN = gtk.gdk.window_foreign_new(long(ident[0]))
		except TypeError, exc:
			_WM_NAME_WIN = ""
	
		name = ""
		win = _WM_NAME_WIN
		if (win != None):
			try:
				name = win.property_get("_NET_WM_NAME")[2]
			except TypeError, exc:
	
				return name

		return name
		
	def auxdestroyed(self):
		#dummy sub for module compatibility
		pass
	
	def destroy(self):
		# External Obliterator
		self.PGL.destroy()
		
		#if Globals.MenuHasIcon==1:
			#self.usericon.destroy(None)
		#self.window.destroy()
		#gtk.main_quit()
		
	def internal_destroy(self,widget,event):
		# Internal Obliterator (event driven)
		self.PGL.destroy()
		
		#if Globals.MenuHasIcon==1:
		 #   self.usericon.destroy(None)
		#self.window.destroy()
		#gtk.main_quit()

#=================================================================
#WINDOW SETUP
#=================================================================

	def draw_scaled_image(self,ctx,x,y, pix, w, h):
		"""Draws a picture from specified path with a certain width and height"""

		ctx.save()
		ctx.translate(x, y)	
		pixbuf = gtk.gdk.pixbuf_new_from_file(pix).scale_simple(w,h,gtk.gdk.INTERP_HYPER)
		format = cairo.FORMAT_RGB24
		if pixbuf.get_has_alpha():
			format = cairo.FORMAT_ARGB32

		iw = pixbuf.get_width()
		ih = pixbuf.get_height()
		image = cairo.ImageSurface(format, iw, ih)

		matrix = cairo.Matrix(xx=iw/w, yy=ih/h)
		image = ctx.set_source_pixbuf(pixbuf, 0, 0)
		if image != None :image.set_matrix(matrix)
		ctx.paint()
		puxbuf = None
		image = None
		ctx.restore()

	def draw_image(self,ctx,x,y, pix):
		"""Draws a picture from specified path with a certain width and height"""

		ctx.save()
		ctx.translate(x, y)	
		pixbuf = gtk.gdk.pixbuf_new_from_file(pix)
		if Globals.flip != None:
			pixbuf = pixbuf.flip(Globals.flip)
		image = ctx.set_source_pixbuf(pixbuf, 0, 0)
		ctx.paint()
		puxbuf = None
		image = None
		ctx.restore()

	def draw_image_gtk(self,ctx,x,y, pix):
		"""Draws a picture from specified path with a certain width and height"""

		ctx.save()
		ctx.translate(x, y)	
		pixbuf = gtk.gdk.pixbuf_new_from_file(pix)
		bgcolor = self.window.get_style().bg[gtk.STATE_NORMAL]
		r = (bgcolor.red*255)/65535.0
		g = (bgcolor.green*255)/65535.0
		b = (bgcolor.blue*255)/65535.0
		colorpb= pixbuf.copy()
		for row in colorpb.get_pixels_array():
		        for pix in row:
			        pix[0] = r
		                pix[1] = g
                		pix[2] = b

		alpha = 255#int(int(70) * 2.55 + 0.2)
		tk = 2
		bg = gtk.gdk.Pixbuf(gtk.gdk.COLORSPACE_RGB, True, 8, self.w,self.h)
		bg.fill(0x00000000)
		glow = bg.copy()
		# Prepare the glow that should be put bind the icon
		tk1 = tk - int(tk/2)
		
		colorpb.composite(glow, 0, 0, self.w, self.h, 0,0, 1, 1, gtk.gdk.INTERP_BILINEAR, 255)
		glow.composite(bg, 0, 0, self.w, self.h, 0, 0, 1, 1, gtk.gdk.INTERP_BILINEAR, alpha)
		pixbuf.composite(bg, 0, 0, self.w, self.h, 0, 0, 1, 1, gtk.gdk.INTERP_BILINEAR, 70)
		pixbuf = bg
		if Globals.flip != None:
			pixbuf = pixbuf.flip(Globals.flip)
		image = ctx.set_source_pixbuf(pixbuf, 0, 0)
		ctx.paint()
		puxbuf = None
		image = None
		ctx.restore()

	def draw_enhanced_image(self,ctx,x,y, pix):
		"""Draws a picture from specified path with a certain width and height"""

		ctx.save()
		ctx.translate(x, y)	
		pixbuf = gtk.gdk.pixbuf_new_from_file(pix)
		if Globals.flip != None:
			pixbuf = pixbuf.flip(Globals.flip)
		iw = pixbuf.get_width()
		ih = pixbuf.get_height()
		#We do this so the themes with fully transparent background are still clickable
		pixbuf.composite(pixbuf, 0, 0, iw, ih, 0, 0, 1, 1, gtk.gdk.INTERP_HYPER, 255)
		pixbuf.composite(pixbuf, 0, 0, iw, ih, 0, 0, 1, 1, gtk.gdk.INTERP_HYPER, 255)
		image = ctx.set_source_pixbuf(pixbuf, 0, 0)
		ctx.paint()
		puxbuf = None
		image = None
		ctx.restore()

	def get_image_size(self,pix):
		"""Gets a picture width and height"""

		pixbuf = gtk.gdk.pixbuf_new_from_file(pix)
		iw = pixbuf.get_width()
		ih = pixbuf.get_height()
		puxbuf = None
		return iw,ih

	def expose (self, widget, event):
		self.ctx = widget.window.cairo_create()
		# set a clip region for the expose event
		self.ctx.save()
		if self.supports_alpha == False:
			self.ctx.set_source_rgb(1, 1, 1)
		else:
			self.ctx.set_source_rgba(1, 1, 1,0)
		self.ctx.set_operator (cairo.OPERATOR_SOURCE)
		self.ctx.paint()
		self.ctx.restore()
		self.ctx.rectangle(event.area.x, event.area.y,
				event.area.width, event.area.height)
		self.ctx.clip()
		if Globals.GtkColors == 1 and Globals.Has_Numpy:
			self.draw_image_gtk(self.ctx,0,0,Globals.ImageDirectory + Globals.StartMenuTemplate)
			
		else:	
			self.draw_image(self.ctx,0,0,Globals.ImageDirectory + Globals.StartMenuTemplate)



	def shape(self):
		#Standard shape setup of window
		w,h = self.window.get_size()
		if w==0: w = 100
		if h==0: h = 100
		self.w = w
		self.h = h
		self.pixmap = gtk.gdk.Pixmap (None, w, h, 1)
		ctx = self.pixmap.cairo_create()
		self.bgpb = gtk.gdk.pixbuf_new_from_file(Globals.ImageDirectory + Globals.StartMenuTemplate)
		if Globals.GtkColors == 1 and Globals.Has_Numpy:
			
			bgcolor = self.window.get_style().bg[gtk.STATE_NORMAL]
			r = (bgcolor.red*255)/65535.0
			g = (bgcolor.green*255)/65535.0
			b = (bgcolor.blue*255)/65535.0
			colorpb= self.bgpb.copy()
			for row in colorpb.get_pixels_array():
			        for pix in row:
				        pix[0] = r
			                pix[1] = g
	                		pix[2] = b
	
			alpha = 255#int(int(70) * 2.55 + 0.2)
			tk = 2
			bg = gtk.gdk.Pixbuf(gtk.gdk.COLORSPACE_RGB, True, 8, self.w,self.h)
			bg.fill(0x00000000)
			glow = bg.copy()
			# Prepare the glow that should be put bind the icon
			tk1 = tk - int(tk/2)
			      
			colorpb.composite(glow, 0, 0, self.w, self.h, 0, 0, 1, 1, gtk.gdk.INTERP_BILINEAR, 255)
			glow.composite(bg, 0, 0, self.w, self.h, 0, 0, 1, 1, gtk.gdk.INTERP_BILINEAR, alpha)
			self.bgpb.composite(bg, 0, 0, self.w, self.h, 0, 0, 1, 1, gtk.gdk.INTERP_BILINEAR, 70)
	
			self.bgpb = bg
			
		#self.bgpb.composite(self.bgpb, 0, 0, w, h, 0, 0, 1, 1, gtk.gdk.INTERP_HYPER, 255)
		#self.bgpb.composite(self.bgpb, 0, 0, w, h, 0, 0, 1, 1, gtk.gdk.INTERP_HYPER, 255)

		ctx.save()
		ctx.set_source_rgba(1, 1, 1,0)
		ctx.set_operator (cairo.OPERATOR_SOURCE)
		ctx.paint()
		ctx.restore()
		if Globals.MenuHasIcon==1:
			self.draw_image(ctx,Globals.UserIconFrameOffsetX,Globals.UserIconFrameOffsetY,Globals.UserImageFrame)
			w,h = self.get_image_size(Globals.UserImageFrame)
			self.draw_scaled_image(ctx,Globals.IconInX +Globals.UserIconFrameOffsetX,Globals.UserIconFrameOffsetY+Globals.IconInY,Globals.UserImage,Globals.IconInW ,Globals.IconInH)
		self.draw_enhanced_image(ctx,0,0,Globals.ImageDirectory + Globals.StartMenuTemplate)

		if self.window.is_composited():
			self.window.input_shape_combine_mask(self.pixmap,0,0)
		else:
			self.window.shape_combine_mask(self.pixmap, 0, 0)


	def setup(self):
		

		self.menuframe = gtk.Fixed()
		self.window.add (self.menuframe)
		self.background =  gtk.Image()
		self.menuframe.put(self.background,0,0)
		w,h = self.window.get_size()
		if w==0: w = 100
		if h==0: h = 100
		self.w = w
		self.h = h
		self.shape()

		if Globals.MenuHasIcon==1:
			self.usericon = ImageFrame(Globals.IconW,Globals.IconH,Globals.IconInX,Globals.IconInY,Globals.IconInW,Globals.IconInH,self.menuframe,self.bgpb)
			self.usericonstate = 0
			self.LastUserPicName = ""
		
		
		#Menu Buttons
		self.MenuButtons = []
		for i in range(0,Globals.MenuButtonCount):
			if Globals.MenuButtonNames[i] == ":SEPARATOR:":
				self.MenuButtons.append(Separator(i,self.menuframe))
			else:
				self.MenuButtons.append(MenuButton(i,self.menuframe,self.bgpb))
				
				self.MenuButtons[i].Button.connect("enter-notify-event", self.Button_enter)
				self.MenuButtons[i].Button.connect("leave-notify-event", self.Button_leave)
				self.MenuButtons[i].Button.connect("button-release-event", self.Button_click)

		#Menu Labels
		self.MenuLabels = []
		for i in range(0,Globals.MenuLabelCount):
			self.MenuLabels.append(MenuLabel(i,self.menuframe))

			
		# Configure the Program List
		if Globals.Prog_List == 0:
			self.PGL = TreeProgramList()
			self.PGL.connect ('menu', self.menu_callback)
			self.PGL.connect ('clicked', self.menu_clicked)
			self.PGL.connect ('clicked', self.menu_clicked)
			self.PGL.connect ('right-clicked', self.menu_right_clicked)
		elif Globals.Prog_List == 1 or Globals.Prog_List == 2:
			self.PGL = ProgramList()
			self.PGL.connect ('menu', self.menu_callback)
			self.PGL.connect ('clicked', self.menu_clicked)
			self.PGL.connect ('right-clicked', self.menu_right_clicked)
		else:	
			self.PGL = CairoProgramList()

		
		self.PGL.ProgramListPopulate(self.menuframe, self.hide_method)
		# Pass widget focus to the text entry box
		if Globals.MenuHasSearch:

			if Globals.SearchWidget.upper() == "CUSTOM":
				if Globals.SearchBackground:
					from Menu_Widgets import  CustomSearchBar
					gobject.type_register(CustomSearchBar)
					self.SearchBar =  CustomSearchBar(Globals.ImageDirectory + Globals.SearchBackground,Globals.SearchInitialText,Globals.SearchTextColor,Globals.SearchIX,Globals.SearchIY)
				else:
					self.SearchBar =  CustomSearchBar(None,Globals.SearchInitialText,Globals.SearchTextColor,Globals.SearchIX,Globals.SearchIY)

			elif Globals.SearchWidget.upper() == "GTK":
				from Menu_Widgets import  GtkSearchBar
				gobject.type_register(GtkSearchBar)
				self.SearchBar = GtkSearchBar()
				self.SearchBar.set_text(_('Search'))
				self.SearchBar.set_inner_border(None)

			elif Globals.SearchWidget.upper() == "CAIRO":
				from Menu_Widgets import  CairoSearchBar
				gobject.type_register(CairoSearchBar)
				self.SearchBar =  CairoSearchBar(Globals.CairoSearchBackColor,Globals.CairoSearchBorderColor,Globals.CairoSearchTextColor)
				self.SearchBar.set_text(_('Search'))
				self.SearchBar.set_inner_border(None)


			try:
				self.SearchBar.set_size_request(Globals.SearchW, Globals.SearchH)
				self.menuframe.put(self.SearchBar, Globals.SearchX, Globals.SearchY)
				#self.SearchBar.connect("activate",self.SearchBarActivate)
	
				self.SearchBar.connect("key-release-event",self.SearchBarActivate)
			except:print 'wait'
			self.prevsearchitem = ""

		#Tab Buttons
		self.MenuTabs = []
		for i in range(0,Globals.MenuTabCount):
			self.MenuTabs.append(MenuTab(i,self.menuframe,self.bgpb))
			if Globals.TabHover:
				self.MenuTabs[i].Tab.connect("enter-notify-event", self.Tab_hover)
			else:
				self.MenuTabs[i].Tab.connect("button-release-event", self.Tab_click)

			if i == 0:
				self.PGL.CallSpecialMenu(Globals.MenuTabCommands[i])
				self.MenuTabs[i].SetSelectedTab(True)
			else:
				self.MenuTabs[i].SetSelectedTab(False)
		#Standalone images
		self.MenuImages = []
		for i in range(0,Globals.MenuImageCount):
			self.MenuImages.append(MenuImage(i,self.menuframe,self.bgpb))

		if has_gst:
			self.StartEngine()
			

	def menu_callback(self,event):
		
		self.leave_focus = False
		if self.leave_focus == False:
			self.callback = gobject.timeout_add(500,self.timeout_callback)

	def menu_clicked(self,event):
		self.PlaySound(2)


	def menu_right_clicked(self,event):

		self.leave_focus = False
		self.callback = gobject.timeout_add(500,self.timeout_callback)


	def Adjust_Window_Dimensions(self, win_x, win_y):
		tmp = self.window.get_size()
		win_x = win_x + Globals.StartMenuXOffset

		# Change from beta 1, make it go down if in the top part of the screen
		# May want to adjust theme to make it look prettier when doing this tho

		self.screenmidpty = int(Globals.screenheight / 2)
		if win_y < self.screenmidpty:
			win_y = win_y - Globals.StartMenuYOffset
		else:
			win_y = win_y - tmp[1] + Globals.StartMenuYOffset
		self.win_x = win_x
		self.win_y = win_y
		self.window.move(win_x, win_y)

	def composite_changed(self,widget):
		self.hide_method()
		self.show_window()	
		if not self.window.is_composited():
 
			self.supports_alpha = False
		else:
			self.supports_alpha = True
		self.shape()

	def show_window(self):
		# This will fail if focus stealing prevention is enabled!
		print 'show'
		
		while gtk.events_pending():
			gtk.main_iteration()
		self.window.set_keep_above(1)
		self.window.show_all()
		self.window.set_keep_above(0)
		self.ChangeUserPic_Normalise()
		self.PGL.SetFirstButton(0)
		self.PlaySound(0)
		
		
		
	def lose_focus(self,widget,event):
		print 'focus lost'
		if self.leave_focus == True:
			self.hide_method()
		
		

	def hide_window(self):
		print 'hide'
		while gtk.events_pending():
			gtk.main_iteration()		
		if self.window.window.is_visible()== True:
			self.window.hide()
			
			if Globals.MenuTabCount == 0:
				self.PGL.Restart()
			if Globals.MenuHasSearch:
				try:self.SearchBar.set_text(_('Search'))
				except:pass
		self.PlaySound(1)
		
	def key_down (self,widget,event):
		# Focus mapping and key press management
		# (this is not the only key event routine set for the menu, also check the PGMenu routines)
		key = event.hardware_keycode
		print key
		if key == 9:	#Escape Key, hides window
			self.hide_method()

		#if key == 22 and (self.SearchBar.text == (_('Search')) or self.SearchBar.text == '') :
		#	self.SearchBar.set_text('')

		elif key == 98 or key == 104 or key == 102 or key == 100 or key == 36 or key == 116 or key ==111 or key == 113 or key == 114 or key == 23:
			# Menu naviagation keys give focus to program list
			if Globals.MenuHasSearch:
				if self.SearchBar.is_focus() == True:
					if key==36 and self.PGL.XDG.searchresults!=0: # Enter on searchbar launches first item in search list
						self.PGL.CallSpecialMenu(6)
						self.hide_method()
					self.PGL.BanFocusSteal = False
					self.PGL.SetInputFocus()

			if key == 23 :
				for i in range(0,Globals.MenuTabCount):
					if self.MenuTabs[i].GetSelectedTab():
						c = i+1
						if c > Globals.MenuTabCount-1:
							c = 0
				for i in range(0,Globals.MenuTabCount):
					if i == c:
						self.MenuTabs[i].SetSelectedTab(True)
						if Globals.MenuTabSub[i] == 0:
			
							self.command = self.LookUpCommand(Globals.MenuTabCommands[i])
			
							os.system(self.command)
			
					 	else:
							self.PGL.CallSpecialMenu(int(Globals.MenuTabCommands[i]))
			
						# Close menu if specified by theme
						if Globals.MenuTabClose[i] == 1 and self.leave_focus == True:
							self.hide_method()
						#self.PGL.Restart()
						if self.leave_focus == False:
							self.callback = gobject.timeout_add(3000,self.timeout_callback)
					else:
						self.MenuTabs[i].SetSelectedTab(False)

				self.PlaySound(3)

			if key == 36:

				self.PlaySound(2)
			

		else:	#Any other key passes through to search bar
			if Globals.MenuHasSearch:
				if self.SearchBar.is_focus() == False:
					self.SearchBar.grab_focus()
				self.SearchBarActivate()



#=================================================================
#Menu Buttons
#=================================================================
	def Button_enter(self,widget,event):
		# Change button background
		i = self.GetButtonIndex(widget)
		self.MenuButtons[i].Setimage(Globals.ImageDirectory + Globals.MenuButtonImage[i])
		if Globals.MenuButtonIconSel[i]:
			self.MenuButtons[i].SetIcon(Globals.ImageDirectory + Globals.MenuButtonIconSel[i])
		try:
			gobject.source_remove(self.timeout_button)
		except:pass
		self.timeout_button = gobject.timeout_add(500,self.button_has_entered,widget,event)



	def button_has_entered(self,widget,event):

		
		# User Icon Code 
		# fixme: no support for non fade icons
		i = self.GetButtonIndex(widget)
		if Globals.MenuButtonExecOnHover[i]:

			self.Button_click(widget,event)
		if Globals.MenuCairoIcon[i]:
			if Globals.MenuHasIcon==1 and Globals.MenuHasFade == 1:

				if Globals.System_Icons:
					try:
						ico = gtk.icon_theme_get_default().lookup_icon(str(Globals.MenuCairoSystemIcon[Globals.MenuCairoIcon[i].replace('.png','').replace('.svg','').replace('.xpm','')]),96,gtk.ICON_LOOKUP_USE_BUILTIN)
						if ico: ico = ico.get_filename()
					except: ico = Globals.IconDirectory + Globals.MenuCairoIcon[i]				
					if not ico: 
						ico = "/usr/share/icons/application-default-icon.png"
						if not os.path.isfile(ico):
							ii = gtk.icon_theme_get_default().lookup_icon("stock_unknown",Globals.PG_iconsize,gtk.ICON_LOOKUP_USE_BUILTIN);
							if ii:
								ico = ii.get_filename()
					
				else: ico = Globals.IconDirectory + Globals.MenuCairoIcon[i]

				self.UserPicName =  ico
				if self.LastUserPicName!=self.UserPicName and self.supports_alpha:
					self.LastUserPicName=self.UserPicName
					#self.usericon.iconopacity = [0,0,1,0]
					if self.usericonstate == 0:
						self.usericon.updateimage(2,self.UserPicName)
						self.usericon.transition([-1,-1,1,0],Globals.TransitionS,Globals.TransitionQ,None)
					elif self.usericonstate == 1:
						self.usericon.updateimage(3,self.UserPicName)
						self.usericon.transition([-1,-1,-1,1],Globals.TransitionS,Globals.TransitionQ,None)
					elif self.usericonstate == 2:
						self.usericon.updateimage(2,self.UserPicName)
						self.usericon.transition([-1,-1,1,-1],Globals.TransitionS,Globals.TransitionQ,None)
					if self.usericonstate == 1:
						self.usericonstate = 2
					else:
						self.usericonstate = 1


	def button_has_leave(self,widget,event):


		# User Icon code
		if Globals.MenuHasFade == 1:
			self.LeaveCustomState()

	def Button_leave(self,widget,event):
		# Button background
		i = self.GetButtonIndex(widget)
		self.MenuButtons[i].SetBackground()
		if Globals.MenuButtonIcon[i]:
			self.MenuButtons[i].SetIcon(Globals.ImageDirectory + Globals.MenuButtonIcon[i])
		gobject.source_remove(self.timeout_button)
		self.timeout_button = gobject.timeout_add(500,self.button_has_leave,widget,event)

	
	def GetButtonIndex(self,widget):
		#Get index from event box
		for i in range(0,Globals.MenuButtonCount):
			if Globals.MenuButtonNames[i] != ":SEPARATOR:":
				if self.MenuButtons[i].Button == widget:
					return i

	def Button_click(self,widget,event):
		i = self.GetButtonIndex(widget)

		# Launch standard menu command
		if Globals.MenuButtonSub[i] == 0:
			
			self.command = self.LookUpCommand(Globals.MenuButtonCommands[i])
			print self.command
			os.system(self.command)
			
	 	else:
			self.PGL.CallSpecialMenu(int(Globals.MenuButtonCommands[i]))
			
		# Close menu if specified by theme
		if Globals.MenuButtonClose[i] == 1 and self.leave_focus == True:
			self.hide_method()
		#self.PGL.Restart()
		if self.leave_focus == False:
			self.callback = gobject.timeout_add(3000,self.timeout_callback)

		self.PlaySound(2)
		


	def Tab_enter(self,widget,event):
		for ii in range(0,Globals.MenuTabCount):
			if self.MenuTabs[ii].Tab == widget:
					i = ii
			else:
				self.MenuTabs[ii].SetSelectedTab(False)
			
		self.MenuTabs[i].SetSelectedTab(True)
		
		# Launch standard menu command
		if Globals.MenuTabSub[i] == 0:
			
			self.command = self.LookUpCommand(Globals.MenuTabCommands[i])
			
			os.system(self.command)
			
	 	else:
			self.PGL.CallSpecialMenu(int(Globals.MenuTabCommands[i]))
			
		# Close menu if specified by theme
		if Globals.MenuTabClose[i] == 1 and self.leave_focus == True:
			self.hide_method()
		#self.PGL.Restart()
		if self.leave_focus == False:
			self.callback = gobject.timeout_add(3000,self.timeout_callback)

	def Tab_hover(self,widget,event):
		for ii in range(0,Globals.MenuTabCount):
			if self.MenuTabs[ii].Tab == widget:
					i = ii
			else:
				self.MenuTabs[ii].SetSelectedTab(False)

			
		self.MenuTabs[i].SetSelectedTab(True)

		# Launch standard menu command
		if Globals.MenuTabSub[i] == 0:
			
			self.command = self.LookUpCommand(Globals.MenuTabCommands[i])
			
			os.system(self.command)
			
	 	else:
			self.PGL.CallSpecialMenu(int(Globals.MenuTabCommands[i]))
			
		# Close menu if specified by theme
		if Globals.MenuTabClose[i] == 1 and self.leave_focus == True:
			self.hide_method()
		#self.PGL.Restart()
		if self.leave_focus == False:
			self.callback = gobject.timeout_add(3000,self.timeout_callback)


	def Tab_click(self,widget,event):
		for ii in range(0,Globals.MenuTabCount):
			if self.MenuTabs[ii].Tab == widget:
					i = ii
			else:
				self.MenuTabs[ii].SetSelectedTab(False)
			
		self.MenuTabs[i].SetSelectedTab(True)

		# Launch standard menu command
		if Globals.MenuTabSub[i] == 0:
			
			self.command = self.LookUpCommand(Globals.MenuTabCommands[i])
			
			os.system(self.command)
			
	 	else:
			self.PGL.CallSpecialMenu(int(Globals.MenuTabCommands[i]))
			
		# Close menu if specified by theme
		if Globals.MenuTabClose[i] == 1 and self.leave_focus == True:
			self.hide_method()
		#self.PGL.Restart()
		if self.leave_focus == False:
			self.callback = gobject.timeout_add(3000,self.timeout_callback)

		self.PlaySound(3)



	def timeout_callback(self):
		self.leave_focus = True
		return False


	def xdg_dir(self,key):
		"""http://www.freedesktop.org/wiki/Software/xdg-user-dirs"""
		try:
			user_dirs = bd.xdg_config_home + '/user-dirs.dirs'
		except:
			user_dirs = os.path.expanduser("~/.config/user-dirs.dirs")
		if os.path.exists(user_dirs):
			f = open(user_dirs, "r")
			for line in f.readlines():
				if line.startswith(key):
					return os.path.expandvars(line[len(key)+2:-2])
		return False

	def LookUpCommand(self,command):
		print command
		if command.lower() == 'home':
			command= os.path.expanduser("~")
			return 'xdg-open ' + command + ' &'
		if command.lower() == 'network':
			command = "network:///"
			return 'xdg-open ' + command + ' &'
		elif command.lower() == 'computer':
			command = "computer:///"
			return 'xdg-open ' + command + ' &'
		elif command.lower() == 'trash':
			command = "trash:///"
			return 'xdg-open ' + command + ' &'
		
		if self.xdg_dir("XDG_" + str(command).upper() + "_DIR") != False:
			command = self.xdg_dir("XDG_" + str(command).upper() + "_DIR")
			command = urllib.unquote(command)
			return 'xdg-open ' + command + ' &'
		
		for i in range(0,len(Globals.MenuActions)):
			if Globals.MenuActions[i]==command:
				return Globals.MenuCommands[i]+ ' &'
		if command.find(':ALLAPPS:') != -1:
			self.leave_focus = False
			return "python -u " + Globals.ProgramDirectory + "Gnome_menu.py"
			
		print str(command) + " - Running custom command"
		return command + ' &'

#=================================================================
#USERICON METHODS
#=================================================================
	def LeaveCustomState(self):	#FIXME This is for fade back to normal, CUP_Norm is for quick switching
		if self.LastUserPicName != "":self.ChangeUserPic_Normalise()

	def ChangeUserPic_Normalise(self):
		# Restore userpic to mode 2  (speed lag if overwriting already current values)
		# Place the usericon		
		if Globals.MenuHasIcon==1:
			self.usericon.move(Globals.UserIconFrameOffsetX,Globals.UserIconFrameOffsetY)
			self.usericon.updateimage(0,Globals.UserImageFrame)
			self.usericon.updateimage(1,Globals.UserImage)
			self.usericon.transition([1,1,-1,-1],Globals.TransitionS,Globals.TransitionQ,None)
			self.usericonstate == 0
			self.LastUserPicName = ""
			
#=================================================================
#PLAY
#=================================================================			


	def StartEngine(self):
		self.player = gst.element_factory_make("playbin", "player")
		fakesink = gst.element_factory_make('fakesink', "my-fakesink")
		self.player.set_property("video-sink", fakesink)
		self.player_bus = self.player.get_bus()
		self.player_bus.add_signal_watch()
		self.player_bus.connect('message', self.on_message)

	def on_message(self, bus, message):
		t = message.type
		if t == gst.MESSAGE_EOS:
			self.player.set_state(gst.STATE_NULL)
			#self.button.set_label("Start")
		elif t == gst.MESSAGE_ERROR:
			self.player.set_state(gst.STATE_NULL)
			#self.button.set_label("Start")

	def PlaySound(self,sound):

		if Globals.Sound_Theme != 'None':
			if sound == 0:
				uri = 'file://' + INSTALL_PREFIX + '/share/gnomenu/Themes/'+ "Sound" + '/' + Globals.Sound_Theme +  '/show-menu.ogg'
			elif sound == 1:
				uri = 'file://' + INSTALL_PREFIX + '/share/gnomenu/Themes/'+ "Sound" + '/' + Globals.Sound_Theme +  '/hide-menu.ogg'
			elif sound == 2:
				uri = 'file://' + INSTALL_PREFIX + '/share/gnomenu/Themes/'+ "Sound" + '/' + Globals.Sound_Theme + '/button-pressed.ogg'
			elif sound == 3:
				uri = 'file://' + INSTALL_PREFIX + '/share/gnomenu/Themes/'+ "Sound" + '/' + Globals.Sound_Theme +  '/tab-pressed.ogg'
	
			if has_gst:
				self.player.set_state(gst.STATE_NULL)
				self.player.set_property('uri',uri)
				self.player.set_state(gst.STATE_PLAYING)
			else:
				os.system('mplayer ' + uri + ' &')


#=================================================================
#SEARCH BAR
#=================================================================
	def SearchBarActivate(self,widget=None,event=None):
		self.searchitem = self.SearchBar.get_text().replace(_('Search'),'')
		self.SearchBar.set_text(self.searchitem)
		try:
			self.font_desc = pango.FontDescription('sans')
			self.SearchBar.modify_font(self.font_desc)
		except:pass
		if self.prevsearchitem != self.searchitem:
			self.PGL.BanFocusSteal = True
			self.prevsearchitem = self.searchitem
			if self.callback_search:
					gobject.source_remove(self.callback_search)
			self.callback_search = gobject.timeout_add(500,self.timeout_callback_search)
			if self.searchitem == '':
				self.SearchBar.set_text(_('Search'))
				try:
					self.font_desc = pango.FontDescription('sans italic')
					self.SearchBar.modify_font(self.font_desc)
				except:pass

	def timeout_callback_search(self):
		self.PGL.CallSpecialMenu(5,self.searchitem)
		print 'search'
		return False

# Code to launch menu standalone of base classes

def destroy():
	hwg.destroy()
	sys.exit()
	
if __name__ == "__main__":
	hwg = Main_Menu(destroy)
	hwg.setup(0,0)
	hwg.show_window()
	gtk.main()
	



